/*
 * glibex.c - Milena Audiobook Creator
 * Copyright (C) Bohdan R. Rau 2011 <ethanak@polip.com>
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.    See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write see:
 *                             <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

void g_string_append_htmlescape(GString *gc,char *c)
{
    char *d;
    for (;*c;) {
        d=strpbrk(c,"\"&<>");
        if (!d) {
            g_string_append(gc,c);
            return;
        }
        g_string_append_len(gc,c,d-c);
        c=d;
        while (*c && strchr("\"&<>",*c)) {
            if (*c=='&') g_string_append(gc,"&amp;");
            else if (*c=='<') g_string_append(gc,"&lt;");
            else if (*c=='>') g_string_append(gc,"&gt;");
            else g_string_append(gc,"&quot;");
            c++;
        }
    }
}

gunichar g_utf8_fetch_char(char **ptr)
{
    gunichar g=g_utf8_get_char(*ptr);
    if (g) *ptr=g_utf8_next_char(*ptr);
    return g;
}
